program offlinereg;

{Copyright 2010 Erwan LABALEC}

{This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.}


{$APPTYPE CONSOLE}

uses
  SysUtils,windows,classes,strutils;

type
PCWSTR=pwidechar;
PWSTR=pwidechar;
PVOID=Pointer;

Const REG_NONE  = 0;
Const REG_SZ  = 1;
Const REG_EXPAND_SZ  = 2;
Const REG_BINARY  = 3;
Const REG_DWORD  = 4;
Const REG_DWORD_LITTLE_ENDIAN  = 4;
Const REG_DWORD_BIG_ENDIAN  = 5;
Const REG_LINK  = 6;
Const REG_MULTI_SZ  = 7;
Const REG_RESOURCE_LIST  = 8;
const REG_FULL_RESOURCE_DESCRIPTOR = 9;
const REG_RESOURCE_REQUIREMENTS_LIST = 10;
Const REG_QWORD  = 11;


var
//http://msdn.microsoft.com/en-us/library/ee210756%28v=VS.85%29.aspx
OROpenHive: function (lpHivePath:PCWSTR;var phkResult:thandle):dword;stdcall;
ORCloseHive:function (ORHKEY:tHandle):dword;stdcall;
OROpenKey:function (ORHKEY:tHandle;lpSubKeyName:PCWSTR;var phkResult:thandle):DWORD;stdcall;
ORCloseKey:function(ORHKEY:tHandle):DWORD;stdcall;
ORGetValue:function(ORHKEY:tHandle;lpSubKey:PCWSTR;lpValue:PCWSTR; pdwType:PDWORD; pvData:PVOID; pcbData:PDWORD):DWORD;stdcall;
ORSetValue:function(ORHKEY:tHandle;lpValueName:PCWSTR;dwType:dword;lpData:pvoid;cbData:dword):dword;stdcall;
ORGetVersion:procedure( var pdwMajorVersion:dword; var pdwMinorVersion:dword);stdcall;
ORSaveHive:function(ORHKEY:tHandle;lpHivePath:PCWSTR;dwOsMajorVersion:dword;dwOsMinorVersion:dword):dword;stdcall;
ORDeleteValue:function(ORHKEY:tHandle;lpValueName:PCWSTR):DWORD;stdcall;
ORDeleteKey:function(ORHKEY:tHandle;lpSubKey:PCWSTR):DWORD;stdcall;
ORCreateKey:function(
  ORHKEY:tHandle;
  lpSubKey:PCWSTR;
  lpClass:PWSTR;
  dwOptions:DWORD;
  pSecurityDescriptor:PSECURITY_DESCRIPTOR;
  phkResult:pointer;
  pdwDisposition:PDWORD):DWORD;stdcall;
OREnumKey:function(
  ORHKEY:tHandle;
  dwIndex:dword;
  lpName:pwstr;
  lpcName:pdword;
  lpClass:PWSTR;
  lpcClass:PDWORD;
  lpftLastWriteTime:PFILETIME):dWORD;stdcall;
 OREnumValue:function(
  ORHKEY:tHandle;
  dwIndex:DWORD;
  lpValueName:PWSTR;
  lpcValueName:PDWORD;
  lpType:PDWORD;
  lpData:PBYTE;
  lpcbData:PDWORD):WORD;stdcall;


ghive,gkeyname,gverb,gvaluename,gvalue:string;
gmajor,gminor,gvaluetype:dword;

function GetOSVersion(var MajorVersion,MinorVersion:dword):boolean;
var
VersionInfo: TOSVersionInfo;
//MajorVersion,MinorVersion,Build: DWORD;
//Platform: string;
begin
  VersionInfo.dwOSVersionInfoSize := SizeOf(VersionInfo);
  if GetVersionEx(VersionInfo) then
  begin
  result:=true;
  with VersionInfo do
  begin
  {
  case dwPlatformId of
   VER_PLATFORM_WIN32s:        Platform := 'Windows 3x';
   VER_PLATFORM_WIN32_WINDOWS: Platform := 'Windows 95';
   VER_PLATFORM_WIN32_NT:      Platform := 'Windows NT';
  end;
  }
  MajorVersion := dwMajorVersion;
  MinorVersion := dwMinorVersion;
  //Build := dwBuildNumber;
  end;
  end; //if GetVersionEx(VersionInfo) then
end;

function Oem (const st : String) : String;
var
  TempBuffer : Array[0..2047] of Char ;
begin
//SetLength (tempbuffer,length(st));
  CharToOem(Pchar(st),@TempBuffer);
  result := StrPas(@TempBuffer);
end;



function getvalue(key:thandle;svaluename:string;var svalue:string):boolean;
var
ret:dword;
wvaluename:array[0..255] of widechar;
binary:array of byte;
pvdata:pointer;
pdwtype,pcbData:pdword;
ws:widestring;
dw:dword;
i:byte;
begin
result:=false;
try
StringToWideChar(svaluename, wvaluename, sizeof(wvaluename));
getmem(pdwType,sizeof(dword));

getmem(pcbdata,sizeof(dword));pcbdata^:=0;
pvdata:=nil;
ret:=ORGetValue (key,nil,wvaluename,pdwtype,pvdata,pcbData);
if ret=0 then
  begin
  if pcbData^=0 then
    begin
    result:=true;
    svalue:='';
    exit;
    end;
  getmem(pvdata,pcbdata^);
  end
  else
  begin
  writeln('ORGetValue failed:'+inttostr(ret));
  exit;
  end;
  
ret:=ORGetValue (key,nil,wvaluename,pdwtype,pvdata,pcbData);
if ret<>0
  then writeln('ORGetValue failed:'+inttostr(ret))
  else
  begin
  result:=true;
  if (pdwtype^=reg_sz) or (pdwtype^=reg_multi_sz) or (pdwtype^=REG_EXPAND_SZ) then
    begin
    setlength(ws,pcbdata^);
    CopyMemory(@ws[1],pvdata,pcbdata^);
    //setlength(svalue,pcbdata^);
    svalue:=ws;
    svalue:=copy(svalue,1,(length(svalue) div 2) -1);
    end;
  if pdwtype^=reg_dword then
    begin
    CopyMemory(@dw,pvdata,pcbdata^);
    svalue:=inttostr(dw);
    end;
  if pdwtype^=reg_binary then
    begin
    setlength(binary,pcbdata^);
    CopyMemory(@binary[0],pvdata,pcbdata^);
    for i:=0 to pcbdata^-1 do svalue:=svalue+' '+inttohex(binary[i],2);
    delete(svalue,1,1);
    end;
  end;
freemem(pdwtype);
freemem(pvdata);
freemem(pcbdata);
except
on e:exception do writeln('getvalue error:'+e.message);
end;
end;

function createkey(key:thandle;skeyname:string):boolean;
var
ret:dword;
wkeyname:array[0..255] of widechar;
hkey:thandle;
begin
result:=false;
try
StringToWideChar(skeyname, wkeyname, sizeof(wkeyname));
ret:=ORCreateKey (key,wkeyname,nil,0,nil,@hkey,nil );
if ret<>0
  then writeln('createkey failed:'+inttostr(ret))
  else result:=true;
except
on e:exception do writeln('createkey error:'+e.message);
end;
end;

function deletekey(key:thandle;skeyname:string):boolean;
var
ret:dword;
wkeyname:array[0..255] of widechar;
begin
result:=false;
StringToWideChar(skeyname, wkeyname, sizeof(wkeyname));
ret:=ORDeleteKey  (key,wkeyname );
if ret<>0
  then writeln('ORDeleteKey failed:'+inttostr(ret))
  else result:=true;
end;

function deletevalue(key:thandle;svaluename:string):boolean;
var
ret:dword;
wvaluename:array[0..255] of widechar;
begin
result:=false;
try
StringToWideChar(svaluename, wvaluename, sizeof(wvaluename));
ret:=ORDeleteValue (key,wvaluename );
if ret<>0
  then writeln('ORDeleteValue failed:'+inttostr(ret))
  else result:=true;
except
on e:exception do writeln('deletevalue error:'+e.message);
end;
end;

function HexToByte(v:string):byte;
//var
   //sMy: string[5];
   //wMy: Word;
begin
     //sMy := 'FFFF';
     //wMy := StrToInt64('$' + sMy);
     result := StrToInt('$' + v);
end;

function setvalue(key:thandle;svaluename,svalue:string;valuetype:dword):boolean;
var
ret:dword;
wvaluename,wvalue:array[0..255] of widechar;
pvdata:pointer;
dwtype,cbData,dw:dword;
i64:int64;
ws:widestring;
tmp:string;
t:tstrings;
binary:array[0..255] of byte;
i:byte;
begin
result:=false;
try
StringToWideChar(svaluename, wvaluename, sizeof(wvaluename));
getmem(pvdata,sizeof(wvalue));
if (valuetype=reg_sz) or (valuetype=reg_multi_sz) or (valuetype=reg_expand_sz) then
begin
  fillchar(wvalue,sizeof(wvalue),0);
  if valuetype=reg_multi_sz then svalue:=AnsiReplacestr(svalue,' ',chr(0));
  StringToWideChar(svalue, wvalue, sizeof(wvalue));
  copymemory(pvdata,@wvalue[0],sizeof(wvalue));
  dwtype:=valuetype;
  cbdata:=length(svalue)*2+2;
  if valuetype=reg_multi_sz then inc(cbdata,2);
  ret:=ORsetValue (key,wvaluename,dwtype,pvdata,cbData);
  if ret<>0
    then writeln('ORsetValue failed:'+inttostr(ret))
    else result:=true;
end; //if (valuetype=reg_sz) or (valuetype=reg_multi_sz) then
if (valuetype=reg_dword) then
begin
  dw:=strtoint(svalue);
  copymemory(pvdata,@dw,sizeof(dword));
  dwtype:=valuetype;
  cbdata:=sizeof(dword);
  ret:=ORsetValue (key,wvaluename,dwtype,pvdata,cbData);
  if ret<>0
    then writeln('ORsetValue failed:'+inttostr(ret))
    else result:=true;
end; //if (valuetype=reg_dword) then
if (valuetype=reg_qword) then
begin
  i64:=StrToInt64 (svalue);
  copymemory(pvdata,@i64,sizeof(int64));
  dwtype:=valuetype;
  cbdata:=sizeof(int64);
  ret:=ORsetValue (key,wvaluename,dwtype,pvdata,cbData);
  if ret<>0
    then writeln('ORsetValue failed:'+inttostr(ret))
    else result:=true;
end; //if (valuetype=reg_dword) then
if (valuetype=reg_binary) then
begin
  t:=tstringlist.Create ;
  t.delimiter :=',';
  t.delimitedtext :=svalue;
  for i:=0 to t.Count -1 do binary[i]:=hextobyte(t[i]);
  cbdata:=t.Count;
  t.Free ;
  copymemory(pvdata,@binary[0],cbdata );
  dwtype:=valuetype;
  ret:=ORsetValue (key,wvaluename,dwtype,pvdata,cbData);
  if ret<>0
    then writeln('ORsetValue failed:'+inttostr(ret))
    else result:=true;
end;
freemem(pvdata);
except
on e:exception do writeln('setvalue error:'+e.message);
end;
end;

function EnumValues(hkey:thandle;var list:tstrings):boolean;
var
ret:dword;
lpname:pwidechar;
lpcname:pdword;
idx:word;
ws:widestring;
lptype:pdword;
begin
result:=false;
try
idx:=0;
getmem(lpname,256);
getmem(lpcname ,sizeof(dword));
getmem(lptype ,sizeof(dword));
ret:=0;
while ret=0 do
  begin
  lpcname^:=256;
  ret:=OREnumValue (hkey,idx,lpname,lpcname,lptype,nil,nil);
  if ret=0 then
    begin
    setlength(ws,lpcname^);
    copymemory(@ws[1],lpname,lpcname^*2);
    list.Add (string(ws));
    inc(idx);
    end;//if ret=0 then
  end;//while ret=0 do
if idx>0 then result:=true else writeln('OREnumValue failed:'+inttostr(ret));
except
on e:exception do writeln('EnumValues error:'+e.message);
end;
end;

function EnumKeys(hkey:thandle;var list:tstrings):boolean;
var
ret:dword;
lpname:pwidechar;
lpcname:pdword;
idx:word;
ws:widestring;
begin
result:=false;
try
idx:=0;
getmem(lpname,256);
getmem(lpcname ,sizeof(dword));
ret:=0;
while ret=0 do
  begin
  lpcname^:=256;
  ret:=OREnumKey(hkey,idx,lpname,lpcname,nil,nil,nil);
  if ret=0 then
    begin
    setlength(ws,lpcname^);
    copymemory(@ws[1],lpname,lpcname^*2);
    list.Add (string(ws));
    inc(idx);
    end;//if ret=0 then
  end;//while ret=0 do
if idx>0 then result:=true else writeln('OREnumKey failed:'+inttostr(ret));
except
on e:exception do writeln('EnumKeys error:'+e.message);
end;
end;

function init:boolean;
var lib:cardinal;
begin
result:=false;
try
lib:=0;
    {$IFDEF win64}lib:=loadlibrary('offreg64.dll');{$endif}
    {$IFDEF win32}lib:=loadlibrary('offreg.dll');{$endif}
if lib<=0 then
  begin
  writeln('could not loadlibrary:'+inttostr(getlasterror));
  exit;
  end;
ORGetVersion:=getProcAddress(lib,'ORGetVersion');
OROpenHive:=getProcAddress(lib,'OROpenHive');
ORCloseHive:=getProcAddress(lib,'ORCloseHive');
ORSaveHive:=getProcAddress(lib,'ORSaveHive');
OROpenKey:=getProcAddress(lib,'OROpenKey');
ORCloseKey:=getProcAddress(lib,'ORCloseKey');
ORGetValue:=getProcAddress(lib,'ORGetValue');
ORSetValue:=getProcAddress(lib,'ORSetValue');
ORDeleteValue:=getProcAddress(lib,'ORDeleteValue');
ORDeleteKey:=getProcAddress(lib,'ORDeleteKey');
ORCreateKey:=getProcAddress(lib,'ORCreateKey');
OREnumKey:=getProcAddress(lib,'OREnumKey');
OREnumValue:=getProcAddress(lib,'OREnumValue');
result:=true;
except
on e:exception do writeln('init error:'+e.message);
end;
end;



procedure main(shive,skeyname,sverb,svaluename:string;svalue:string='';svaluetype:dword=1);
var

hkey,hkresult:thandle;
ret:dword;
wpath,wsubkeyname,wbackup:array[0..255] of widechar;
dwMajorVersion,dwMinorVersion:dword;
sbackup,s:string;
list:tstrings;
idx:word;
begin
try
dwMajorVersion:=0;dwMinorVersion:=0;
hkey:=thandle(-1);
if init=false then exit;
//
StringToWideChar(shive, wpath, sizeof(wpath));
try ret:=OROpenHive(wpath,hkey); except raise exception.Create('OROpenHive failed'); end;
if ret<>0
then writeln('OROpenHive failed:'+inttostr(ret))
else
begin
//do things...
//replace currentcontrolset by the real controlset00x
if pos('CURRENTCONTROLSET',uppercase(skeyname) )>0 then
  begin
  StringToWideChar('select', wsubkeyname, sizeof(wsubkeyname));
  try ret:=OROpenKey (hkey,wsubkeyname,hkresult); except raise exception.Create('OROpenKey failed'); end;
  if ret=0 then
  begin
  getvalue(hkresult,'Current',s);
  if s<>'' then skeyname:=stringreplace(skeyname,'currentcontrolset','controlset00'+s,[rfReplaceAll, rfIgnoreCase]);
  ret:=ORcloseKey (hkresult);
  end;
  end;
//
StringToWideChar(skeyname, wsubkeyname, sizeof(wsubkeyname));
try ret:=OROpenKey (hkey,wsubkeyname,hkresult);except raise exception.Create('OROpenKey failed'); end;
if ret<>0
then writeln('OROpenKey failed:'+inttostr(ret))
else
begin
//setlength(s,2048);
if sverb='enumvalues' then
  begin
  list:=tstringlist.Create ;
  if enumvalues(hkresult,list) then
    begin
    for idx:=0 to list.Count -1 do
      begin
      writeln(list[idx]);
      end; //for idx:=0
    end;// if enumkeys
  list.Free ;
  end;
if sverb='enumallvalues' then
  begin
  list:=tstringlist.Create ;
  if enumvalues(hkresult,list) then
    begin
    for idx:=0 to list.Count -1 do
      begin
      //writeln(list[idx]);

      if getvalue(hkresult,list[idx],s) then writeln('"'+list[idx]+'"='+oem(s));
      end; //for idx:=0
    end;// if enumkeys
  list.Free ;
  end;
if sverb='enumkeys' then
  begin
  list:=tstringlist.Create ;
  if enumkeys(hkresult,list) then
    begin
    for idx:=0 to list.Count -1 do
      begin
      writeln(list[idx]);
      end; //for idx:=0
    end;// if enumkeys
  list.Free ;
  end;
if sverb='createkey'
  then if createkey(hkresult,svaluename) then
  begin
  writeln('createkey ok');
  sbackup:=ChangeFileExt(shive,'.bak');
  StringToWideChar(sbackup, wbackup, sizeof(wbackup));
  {$i-}deletefile(pchar(sbackup));{$i-}
  try ret:=ORSaveHive (hkey,wbackup,gmajor,gminor);except raise exception.Create('ORSaveHive failed'); end;
  if ret=0 then writeln('saved to '+sbackup);
  end;
if sverb='deletekey'
  then if deletekey(hkresult,svaluename) then
  begin
  writeln('deletekey ok');
  sbackup:=ChangeFileExt(shive,'.bak');
  StringToWideChar(sbackup, wbackup, sizeof(wbackup));
  {$i-}deletefile(pchar(sbackup));{$i-}
  ret:=ORSaveHive (hkey,wbackup,gmajor,gminor);
  if ret=0 then writeln('saved to '+sbackup);
  end;
if sverb='deletevalue'
  then if deletevalue(hkresult,svaluename) then
  begin
  writeln('deletevalue ok');
  sbackup:=ChangeFileExt(shive,'.bak');
  StringToWideChar(sbackup, wbackup, sizeof(wbackup));
  {$i-}deletefile(pchar(sbackup));{$i-}
  ret:=ORSaveHive (hkey,wbackup,gmajor,gminor);
  if ret=0 then writeln('saved to '+sbackup);
  end;
if sverb='getvalue'
  then if getvalue(hkresult,svaluename,s) then writeln('"'+svaluename+'"='+oem(s));
if sverb='setvalue'
  then if setvalue(hkresult ,svaluename,svalue,svaluetype) then
  begin
  writeln('setvalue ok');
  sbackup:=ChangeFileExt(shive,'.bak');
  StringToWideChar(sbackup, wbackup, sizeof(wbackup));
  {$i-}deletefile(pchar(sbackup));{$i-}
  ret:=ORSaveHive (hkey,wbackup,gmajor,gminor);
  if ret=0 then writeln('saved to '+sbackup);
  end;
ret:=ORcloseKey (hkresult);
if ret<>0 then writeln('ORcloseKey failed:'+inttostr(ret));
end; //OROpenKey
//
try ret:=ORCloseHive (hkey); except raise exception.Create('ORSaveHive failed'); end;
if ret<>0 then writeln(inttostr(ret));
end; //OROpenHive
except
on e:exception do writeln('main error:'+e.message);
end;
end;

//******************************************************************

begin
GetOSVersion(gmajor,gminor);
//writeln('OS '+inttostr(gmajor)+'.'+inttostr(gminor));
//writeln(inttostr(paramcount));
if paramcount=0 then
  begin
  writeln('OfflineReg v0.9 by Erwan.L - http://erwan.labalec.fr/ - erwan2212@gmail.fr');
  writeln('Main Usage : OfflineReg hivepath keypath verb argument(s)');
  writeln('Example : OfflineReg "c:\temp\system" a_key_path getvalue a_value_name');
  writeln('Example : OfflineReg "c:\temp\system" a_key_path setvalue a_value_name a_new_value');
  writeln('Example : OfflineReg "c:\temp\system" a_key_path setvalue a_dword_key_name a_dword_value 4 ');
  writeln('Example : OfflineReg "c:\temp\system" a_key_path setvalue a_qword_key_name a_qword_value 11 ');
  writeln('Example : OfflineReg "c:\temp\system" a_key_path setvalue a_binary_key_name 0a,0b,0c,0d,0e,0f 3 ');
  writeln('Example : OfflineReg "c:\temp\system" a_key_path setvalue a_multi_value_name "aa bb cc dd" 7');
  writeln('Example : OfflineReg "c:\temp\system" a_key_path deletevalue a_value');
  writeln('Example : OfflineReg "c:\temp\system" a_key_path deletekey a_key');
  writeln('Example : OfflineReg "c:\temp\system" a_key_path createkey a_key');
  writeln('Example : OfflineReg "c:\temp\system" a_key_path enumkeys');
  writeln('Example : OfflineReg "c:\temp\system" a_key_path enumvalues');
  writeln('Example : OfflineReg "c:\temp\system" a_key_path enumallvalues');
  exit;
  end;
if paramcount>=3 then
begin
gvalue:='';gvaluename:='';gvaluetype:=1;
ghive :=paramstr(1);
gkeyname:=paramstr(2);
if pos('HKEY_CURRENT_CONFIG\',uppercase(gkeyname) )>0 then gkeyname :=StringReplace (gkeyname,'HKEY_CURRENT_CONFIG\','',[rfReplaceAll, rfIgnoreCase]) ;
if pos('HKEY_CURRENT_USER\',uppercase(gkeyname) )>0 then gkeyname :=StringReplace (gkeyname,'HKEY_CURRENT_USER\','',[rfReplaceAll, rfIgnoreCase]) ;
if pos('HKEY_LOCAL_MACHINE\SAM\',uppercase(gkeyname) )>0 then gkeyname :=StringReplace (gkeyname,'HKEY_LOCAL_MACHINE\SAM\','',[rfReplaceAll, rfIgnoreCase]) ;
if pos('HKEY_LOCAL_MACHINE\SECURITY\',uppercase(gkeyname) )>0 then gkeyname :=StringReplace (gkeyname,'HKEY_LOCAL_MACHINE\SECURITY\','',[rfReplaceAll, rfIgnoreCase]) ;
if pos('HKEY_LOCAL_MACHINE\SOFTWARE\',uppercase(gkeyname) )>0 then gkeyname :=StringReplace (gkeyname,'HKEY_LOCAL_MACHINE\SOFTWARE\','',[rfReplaceAll, rfIgnoreCase]) ;
if pos('HKEY_LOCAL_MACHINE\SYSTEM\',uppercase(gkeyname) )>0 then gkeyname :=StringReplace (gkeyname,'HKEY_LOCAL_MACHINE\SYSTEM\','',[rfReplaceAll, rfIgnoreCase]) ;
if pos('HKEY_USERS\.DEFAULT\',uppercase(gkeyname) )>0 then gkeyname :=StringReplace (gkeyname,'HKEY_USERS\.DEFAULT\','',[rfReplaceAll, rfIgnoreCase]) ;
gverb:=paramstr(3);
if paramcount>=4 then gvaluename :=string(paramstr(4));
if paramcount>=5 then gvalue:=string(paramstr(5));
if paramcount>=6 then gvaluetype:=strtoint(paramstr(6));
main(ghive,gkeyname,gverb,gvaluename,gvalue,gvaluetype);
end;
end.
